var EXEMPLES = [
	[ // 0
		["x", "f'(x)", "f(x)"],
		["1", "", "-", "+\\infty"],
		["e", "0", "+", "e"],
		["+\\infty", "", "?", "+\\infty"]
	],
	[ // 1
		["x", "f'(x)", "f(x)"],
		["0", ":", "-", ":+\\infty"],
		["\\dfrac{1}{3}", "0", "+", "8"],
		["1", ":", "?", "+\\infty:"]
	],
	[ // 2
		["x", "f'(x)", "f(x)"],
		["0", "", "+", "0"],
		["\\dfrac{\\pi}{3}", "0", "-", "\\dfrac{3\\sqrt{3}}{4}"],
		["\\pi", "", "?", "0"]
	],
	[ // 3
		["x", "f'(x)", "f(x)"],
		["-\\infty", "", "-", "+\\infty"],
		["0", "0", "+", "-3"],
		["1", "0", "+", "-2"],
		["+\\infty", "", "?", "+\\infty"]
	],
	[ // 4
		["x", "f'(x)", "f(x)"],
		["-\\infty", "", "-", "-\\infty"],
		["a", "0", "+", "0"],
		["+\\infty", "", "?", "+\\infty"]
	],
	[ // 5
		["x", "f'(x)", "f(x)"],
		["-\\infty", "", "+", "-\\infty"],
		["-1", "0", "-", "\\dfrac{3}{2}"],
		["1", "0", "+", "\\dfrac{1}{2}"],
		["+\\infty", "", "?", "+\\infty"]
	],
	[ // 6
		["x", "f'(x)", "f(x)"],
		["-\\infty", "", "+", "0"],
		["0", "0", "+", "1"],
		["+\\infty", "", "?", "+\\infty"]
	],
	[ // 7
		["x", "f'(x)", "f(x)"],
		["0", ":", "+", ":-\\infty"],
		["e^2", "0", "-", "\\dfrac{2}{e}"],
		["+\\infty", "", "?", "0"]
	],
	[ // 8
		["x", "f'(x)", "f(x)"],
		["-\\infty", "", "+", "1"],
		["-1", ":", "?", "+\\infty:"],
		["+1", ":", "-", "0"],
		["+\\infty", "", "?", "-1"]
	],
	[ // 9
		["x", "f'(x)", "f(x)"],
		["-\\infty", "", "-", "0"],
		["0", ":", "-", "-\\infty:+\\infty"],
		["+\\infty", "", "?", "0"]
	],
	[ // 10
		["x", "f'(x)", "f(x)"],
		["-\\infty", "0", "+", "0"],
		["-\\dfrac{1}{e}", "0", "-", "e^{\\frac{1}{e}}"],
		["0", "-\\infty:-\\infty", "-", "1:1"],
		["\\dfrac{1}{e}", "0", "+", "e^{-\\frac{1}{e}}"],
		["+\\infty", "+\\infty", "?", "+\\infty"]
	],
	[ // 11
		["x", "f'(x)", "f(x)"],
		["1", "", "+", "1"],
		["2", "", "-", "2"],
		["3", "0:0", "-", "3:3"],
		["4", "", "+", "4"],
		["5", "", "+", "5"],
		["6", "", "?", "6"]
	],
	[ // 12
		["x", "f'(x)", "f(x)"],
		["1", "", "+", "1"],
		["2", "", "-", "2"],
		["3", "0:0", "-", "3:4"],
		["4", "", "-", "5:6"],
		["5", "", "-", "7"],
		["6", "", "?", "8"]
	],
	[ // 13
		["x", "f'(x)", "f(x)"],
		["1", "", "+", "1"],
		["2", "", "-", "2"],
		["3", "0:0", "-", "3:4"],
		["4", "", "-", "5"],
		["5", "", "-", "6"],
		["6", "", "?", "7"]
	],
	[ // 14
		["x", "f'(x)", "f(x)"],
		["0", ":", "-", ":+\\infty"],
		["\\dfrac{1}{2}", "0", "-", "0"],
		["1", ":", "?", "-\\infty:"]
	],
	[ // 15
		["x", "f'(x)", "f(x)"],
		["-\\infty", "", "-", "-1"],
		["-1", ":", "-", "-\\infty:+\\infty"],
		["0", "", "-", "\\sqrt{2}"],
		["1", "-\\infty:", "?", "0\\updownarrow:"],
		["2", ":+\\infty", "+", ":\\updownarrow0"],
		["+\\infty", "", "?", "1"]
	],
	[
		["x", "y'", "y"],
		["0", "", "+", "0"],
		["1", "", "+", "1"],
		["2", "", "+", "2"],
		["3", "", "+", "3"],
		["4", "", "-", "4"],
		["5", "", "-", "5"],
		["6", "", "-", "6"],
		["7", "", "-", "7"],
		["8", "", "-", "8"],
		["9", "", "+", "9"],
		["10", "", "+", "10"],
		["11", "", "+", "11"],
		["12", "", "?", "12"]
	],
	[
		["x", "y'", "y"],
		["0", "", "+", "0"],
		["1", "", "+", "1"],
		["2", "", "+", "2"],
		["3", "", "-", "3"],
		["4", "", "-", "4"],
		["5", "", "-", "5"],
		["6", "", "-", "6"],
		["7", "", "-", "7"],
		["8", "", "-", "8"],
		["9", "", "+", "9"],
		["10", "", "+", "10"],
		["11", "", "+", "11"],
		["12", "", "?", "12"]
	]
];
