﻿/*globals document, DOM, EXEMPLES, GUI */

var TabVar = {
	yaLaDerivee: true,
	yaLaFonction: true,
	yaLesPointilles: false
};

var TikZ = {
	SourceDebut: "%:-+-+-+-+- Engendré par : http://math.et.info.free.fr/TikZ/TableauxVariations/\n" +
		"\\begin{center}\n" +
		"\\begin{tikzpicture}",
	SourceDefinitions: "% Styles \n\\tikzstyle{cadre}=[thin]\n" +
		"\\tikzstyle{fleche}=[->,>=latex,thin]\n" +
		"\\tikzstyle{nondefini}=[lightgray]\n" +
		"% Dimensions Modifiables\n" +
		"\\def\\Lrg{1.5}\n" +
		"\\def\\HtX{1}\n" +
		"\\def\\HtY{0.5}\n" +
		"% Dimensions Calculées\n" +
		"\\def\\lignex{-0.5*\\HtX}\n" +
		"\\def\\lignef{-1.5*\\HtX}\n" +
		"\\def\\separateur{-0.5*\\Lrg}\n",
	SourcePPdeDetY: "% Pointillés\n" +
		"\\def\\pp#1{\\draw[dashed,gray] (#1,\\lignex-0.1*\\HtX) -- (#1,\\lignef+0.1*\\HtX); \\draw[dashed,gray] (#1,\\lignef-0.1*\\HtX) -- (#1,\\bas+0.1*\\HtX);}",
	SourcePPdeD: "% Pointillés\n" +
		"\\def\\pp#1{\\draw[dashed,gray] (#1,\\lignex-0.1*\\HtX) -- (#1,\\lignef+0.1*\\HtX);}",
	SourcePPdeY: "% Pointillés\n" +
		"\\def\\pp#1{\\draw[dashed,gray] (#1,\\lignex-0.1*\\HtX) -- (#1,\\bas+0.1*\\HtX);}",
	SourceBetBB: "% Doubles Barres\n" +
		"\\def\\b#1{\\draw[double distance=2pt] (#1,\\lignex-0.1*\\HtX) -- (#1,\\lignef+0.1*\\HtX);}\n" +
		"\\def\\bb#1{\\draw[double distance=2pt] (#1,\\lignef-0.1*\\HtX) -- (#1,\\bas+0.1*\\HtX);}",
	SourceB: "% Doubles Barres\n" +
		"\\def\\b#1{\\draw[double distance=2pt] (#1,\\lignex-0.1*\\HtX) -- (#1,\\lignef+0.1*\\HtX);}",
	SourceBB: "% Doubles Barres\n" +
		"\\def\\bb#1{\\draw[double distance=2pt] (#1,\\lignef+0.9*\\HtX) -- (#1,\\bas+0.1*\\HtX);}",
	SourceZdeDetY: "% Zones de non définition\n" +
		"\\def\\z#1#2{\\fill[nondefini] (#1+0.1*\\Lrg,\\lignex-0.1*\\HtX) rectangle (#2-0.1*\\Lrg,\\lignef+0.1*\\HtX); \\fill[nondefini] (#1+0.1*\\Lrg,\\lignef-0.1*\\HtX) rectangle (#2-0.1*\\Lrg,\\bas+0.1*\\HtX);}",
	SourceZdeD: "% Zones de non définition\n" +
		"\\def\\z#1#2{\\fill[nondefini] (#1+0.1*\\Lrg,\\lignex-0.1*\\HtX) rectangle (#2-0.1*\\Lrg,\\lignef+0.1*\\HtX);}",
	SourceZdeY: "% Zones de non définition\n" +
		"\\def\\z#1#2{\\fill[nondefini] (#1+0.1*\\Lrg,\\lignef+0.9*\\HtX) rectangle (#2-0.1*\\Lrg,\\bas+0.1*\\HtX);}",
	SourceFinPourDetY: "% Encadrement\n" +
		"\\draw[cadre] (\\separateur,\\haut) -- (\\separateur,\\bas);\n" +
		"\\draw[cadre] (\\gauche,\\haut) rectangle  (\\droite,\\bas);\n" +
		"\\draw[cadre] (\\gauche,\\lignex) -- (\\droite,\\lignex);\n" +
		"\\draw[cadre] (\\gauche,\\lignef) -- (\\droite,\\lignef);\n" +
		"\\end{tikzpicture}\n" +
		"\\end{center}\n" +
		"%:-+-+-+-+- Fin\n",
	SourceFinPourD: "% Encadrement\n" +
		"\\draw[cadre] (\\separateur,\\haut) -- (\\separateur, \\lignef);\n" +
		"\\draw[cadre] (\\gauche,\\haut) rectangle  (\\droite, \\lignef);\n" +
		"\\draw[cadre] (\\gauche,\\lignex) -- (\\droite,\\lignex);\n" +
		"\\end{tikzpicture}\n" +
		"\\end{center}\n" +
		"%:-+-+-+-+- Fin\n",
	SourceFinPourY: "% Encadrement\n" +
		"\\draw[cadre] (\\separateur,\\haut) -- (\\separateur,\\bas);\n" +
		"\\draw[cadre] (\\gauche,\\haut) rectangle  (\\droite,\\bas);\n" +
		"\\draw[cadre] (\\gauche,\\lignex) -- (\\droite,\\lignex);\n" +
		"\\end{tikzpicture}\n" +
		"\\end{center}\n" +
		"%:-+-+-+-+- Fin\n"
};

//================== Services ==================
//============= TikZ.ajouterPointilles =============
TikZ.ajouterPointilles = function () {
	var k;
	if (TabVar.yaLesPointilles) {
		if (TabVar.yaLaDerivee && TabVar.yaLaFonction) {
			// pointillés pour la dérivée et la fonction 
			TikZ.texteSourceA += TikZ.SourcePPdeDetY + "\n";
		} else if (TabVar.yaLaFonction) {
			// pointillés pour la fonction seulement
			TikZ.texteSourceA += TikZ.SourcePPdeY + "\n";
		} else {
			// pointillés pour la derivée seulement
			TikZ.texteSourceA += TikZ.SourcePPdeD + "\n";
		}
		for (k = 0; k < TabVar.nbCol - 1; k += 1) {
			TikZ.texteSourceA += "\\pp{" + (2 * k) + "*\\Lrg}\n";
		}
	}
};

//============= TikZ.ajouterLeDebug =============
TikZ.ajouterLeDebug = function () {
	var k, old;
	old = TabVar.debug;
	TabVar.debug = false;
	if (TabVar.debug) {
		TikZ.texteSourceB += "% Débug";
		if (TabVar.numeroExo === undefined) {
			TikZ.texteSourceB += "\n";
		} else {
			TikZ.texteSourceB += " Exemple n° " + TabVar.numeroExo + "\n";
		}
		TikZ.texteSourceB += "% TikZ.doubleBarreD : " + TikZ.doubleBarreD.join(" # ") + "\n";
		TikZ.texteSourceB += "% TikZ.doubleBarreY : " + TikZ.doubleBarreY.join(" # ") + "\n";
		TikZ.texteSourceB += "% TikZ.zoneVide : " + TikZ.zoneVide.join(" # ") + "\n";
		TikZ.texteSourceB += "% TikZ.valeurDeY\n";
		for (k = 0; k < TikZ.valeurDeY.length; k += 1) {
			TikZ.texteSourceB += '%    "' + TikZ.valeurDeY[k].join('", "') + '"\n';
		}
		TikZ.texteSourceB += "% TikZ.definitionFleche : [[" + TikZ.definitionFleche.join("], [") + "]]\n";
		TikZ.texteSourceB += "% TikZ.idxDiscont : [" + TikZ.idxDiscont.join(", ") + "]\n";
		TikZ.texteSourceB += "% TabVar.nbCol : " + TabVar.nbCol + "\n";
		TikZ.texteSourceB += "% TabVar.vx : ['" + TabVar.vx.join("', '") + "']\n";
		TikZ.texteSourceB += "% TabVar.vd : ['" + TabVar.vd.join("', '") + "']\n";
		TikZ.texteSourceB += "% TabVar.sd : ['" + TabVar.sd.join("', '") + "']\n";
		TikZ.texteSourceB += "% TabVar.vy : ['" + TabVar.vy.join("', '") + "']\n";
		TikZ.texteSourceB += "% TabVar.vy : ['" + TabVar.vy.join("', '") + "']\n\n";
	}
	TabVar.debug = old;
};

//============= TikZ.defY =============
TikZ.defY = function (positionHorizontale, k) {
	var def;
	if (TabVar.vy[k].length > 1) {
		// Split : double barre || avant:après
		// on mémorise la position verticale de la double barre
		TikZ.doubleBarreY.push(positionHorizontale + "*\\Lrg");
		TikZ.numeroDuNoeud += 1;
		// on mémorise la définition du noeud gauche
		def = ["(f" + TikZ.numeroDuNoeud + ")", "$" + TabVar.vy[k][0] + "$", positionHorizontale, TikZ.hauteurNoeud, "[left]", k];
		TikZ.valeurDeY.push(def);
		TikZ.idxDiscont.push(TikZ.valeurDeY.length);
		// après une discontinuité on remet la hauteur à zéro
		TikZ.hauteurNoeud = 0;
		if (TabVar.sd[k] !== "?") {
			TikZ.numeroDuNoeud += 1;
			// on mémorise la définition du noeud droite
			def = ["(f" + TikZ.numeroDuNoeud + ")", "$" + TabVar.vy[k][1] + "$", positionHorizontale, TikZ.hauteurNoeud, "[right]", k];
			TikZ.valeurDeY.push(def);
		}
	} else {
		// Valeur unique
		TikZ.numeroDuNoeud += 1;
		// on mémorise la définition du noeud cntre
		def = ["(f" + TikZ.numeroDuNoeud + ")", "$" + TabVar.vy[k][0] + "$", positionHorizontale, TikZ.hauteurNoeud, "", k];
		TikZ.valeurDeY.push(def);
	}
	// on mémorise la définition de la flèche si elle existe (+ ou -)
	if (TabVar.sd[k] === "+") {
		// on monte
		TikZ.hauteurNoeud += 2;
		TikZ.definitionFleche.push([def[0], "(f" + (TikZ.numeroDuNoeud + 1) + ")"]);
	} else if (TabVar.sd[k] === "-") {
		// on descend
		TikZ.hauteurNoeud -= 2;
		TikZ.definitionFleche.push([def[0], "(f" + (TikZ.numeroDuNoeud + 1) + ")"]);
	}
};

//============= TikZ.centrerLigneY =============
TikZ.centrerLigneY = function () {
	var i, j, k, bord, min, max;
	// hauteur totale du cadre à ajuster ensuite pour centrer la ligne
	TikZ.hauteurTotale = 0;
	for (i = 1; i < TikZ.idxDiscont.length; i += 1) {
		// on réinitialise les valeurs min et max
		min = 100;
		max = -100;
		for (k = TikZ.idxDiscont[i - 1]; k < TikZ.idxDiscont[i]; k += 1) {
			if (TikZ.valeurDeY[k][3] < min) {
				min = TikZ.valeurDeY[k][3];
			}
			if (TikZ.valeurDeY[k][3] > max) {
				max = TikZ.valeurDeY[k][3];
			}
		}
		for (k = TikZ.idxDiscont[i - 1]; k < TikZ.idxDiscont[i]; k += 1) {
			// ajuster position verticale du noeud dans la zone (max = 0)
			TikZ.valeurDeY[k][3] = TikZ.valeurDeY[k][3] - max;
		}
		min = min - max;
		max = 0;
		TikZ.hauteurTotale = max - min > TikZ.hauteurTotale ? max - min : TikZ.hauteurTotale;
		// ajuster les hauteurs dans la zone
		// j n° du premier noeud
		j = TikZ.idxDiscont[i - 1];
		// sans dépasser le nombre de colonnes (|| en fin de table) BUG
		if (j >= TikZ.valeurDeY.length) {
			j = TikZ.valeurDeY.length - 1;
		}
		// ajuster hauteur du premier noeud de la colonne
		bord = TikZ.valeurDeY[j][3];
		// n° de la colonne du signe qui suit (+ ou -) 
		k = TikZ.valeurDeY[j][5];
		if (TabVar.sd[k] === "+" && bord > min) {
			// si flèche monte et si trop on descend 
			TikZ.valeurDeY[j][3] = min;
		}
		if (TabVar.sd[k] === "-" && bord < max) {
			// si flèche descend et si pas assez on monte 
			TikZ.valeurDeY[j][3] = max;
		}
		// ajuster hauteur du dernier noeud de la colonne
		j = TikZ.idxDiscont[i] - 1;
		bord = TikZ.valeurDeY[j][3];
		// n° de la colonne du signe qui précède (+ ou -)
		k = TikZ.valeurDeY[j][5] - 1;
		if (TabVar.sd[k] === "+" && bord < max) {
			// si flèche monte et si pas assez on monte 
			TikZ.valeurDeY[j][3] = max;
		}
		if (TabVar.sd[k] === "-" && bord > min) {
			// si flèche descend et si trop on descend 
			TikZ.valeurDeY[j][3] = min;
		}
	}
	// ajustement final de la hauteur par intervalle (lissage)
	for (i = 1; i < TikZ.idxDiscont.length; i += 1) {
		min = 100;
		// recherche du minimum de la zone
		for (k = TikZ.idxDiscont[i - 1]; k < TikZ.idxDiscont[i]; k += 1) {
			if (TikZ.valeurDeY[k][3] < min) {
				min = TikZ.valeurDeY[k][3];
			}
		}
		min = -min;
		// ajustement proportionnel des hauteurs des noeuds
		for (k = TikZ.idxDiscont[i - 1]; k < TikZ.idxDiscont[i]; k += 1) {
			if (min !== 0) {
				TikZ.valeurDeY[k][3] = TikZ.hauteurTotale / min * TikZ.valeurDeY[k][3];
			}
		}
	}
	// ajuster la hauteur totale
	if (TikZ.hauteurTotale > 3) {
		for (k = 0; k < TikZ.valeurDeY.length; k += 1) {
			TikZ.valeurDeY[k][3] = 0.5 * TikZ.valeurDeY[k][3];
		}
		TikZ.hauteurTotale = 0.5 * TikZ.hauteurTotale;
	}
	TikZ.valeurDeY[0][3] = -0.5 * TikZ.hauteurTotale;
};

//============= TikZ.creerTexteSourceLigneY =============
TikZ.creerTexteSourceLigneY = function () {
	var k, positionHorizontale, def;
	// Index des colonnes où il y a une discontinuité [Deb, ... , Fin]
	// Ex: [1, 3, 5]
	TikZ.idxDiscont = [];
	// Description des noeuds de la ligne de la fonction
	// nom du noeud, étiquette, positionH, positionV, [left/right], k (col)
	// Ex: [["(f1)", "$e^2$, "2", "-2", "[right]", "2"], ...]
	TikZ.valeurDeY = [];
	// Description des flèches à tracer
	// nom du noeud début, nom du noeud fin
	// Ex: [["(f1)", "(f2)"], ["(f2)", "(f3)"], ...]
	TikZ.definitionFleche = [];
	// Position verticale des doubles barres dans la ligne de la fonction
	// Ex: ["2*\Lrg", "4*\Lrg", ...]
	TikZ.doubleBarreY = [];
	// hauteur courante du noeud à ajuster ensuite pour centrer la ligne
	TikZ.hauteurNoeud = 0;
	// numéro du noeud courant pour définir son nom (f_i)
	TikZ.numeroDuNoeud = 0;
	// % Ligne de la fonction
	TikZ.texteSourceB += "% Ligne de la fonction : f(x)\n";
	TikZ.idxDiscont.push(1);
	positionHorizontale = 0;
	def = ["", "$" + TabVar.vy[0] + "$", -1, 0, ""];
	TikZ.valeurDeY.push(def);
	for (k = 1; k < TabVar.nbCol; k += 1) {
		TikZ.defY(positionHorizontale, k);
		positionHorizontale += 2;
	}
	TikZ.idxDiscont.push(TikZ.valeurDeY.length);
	TikZ.centrerLigneY();
	if (TabVar.yaLaFonction) {
		// Placer les valeurs de y
		for (k = 0; k < TikZ.valeurDeY.length; k += 1) {
			// placer le noeud selon les valeurs de (2,k)
			TikZ.texteSourceB += "\\node" + TikZ.valeurDeY[k][4] + " " + TikZ.valeurDeY[k][0] + " at (" + TikZ.valeurDeY[k][2] + "*\\Lrg,{-" + (TabVar.yaLaDerivee ? "2" : "1") + "*\\HtX+(" + TikZ.valeurDeY[k][3] + ")*\\HtY}) {" + TikZ.valeurDeY[k][1] + "};\n";
		}
		// Flèches
		TikZ.texteSourceB += "% Flèches\n";
		for (k = 0; k < TikZ.definitionFleche.length; k += 1) {
			TikZ.texteSourceB += "\\draw[fleche] " + TikZ.definitionFleche[k][0] + " -- " + TikZ.definitionFleche[k][1] + ";\n";
		}
	}
	// Hauteur
	TikZ.texteSourceA += "% Hauteur du tableau\n";
	TikZ.texteSourceA += "\\def\\haut{0.5*\\HtX}\n";
	TikZ.texteSourceA += "\\def\\bas{-" + (TabVar.yaLaDerivee ? "2" : "1") + ".5*\\HtX-" + (TikZ.hauteurTotale) + "*\\HtY}\n";
};

//============= TikZ.defD =============
TikZ.defD = function (positionHorizontale, k) {
	if (TabVar.vd[k].length > 1) {
		// Split : double barre || avant:après
		// on mémorise la position verticale de la double barre
		TikZ.doubleBarreD.push(positionHorizontale + "*\\Lrg");
		if (TabVar.vd[k][0] !== "" && TabVar.yaLaDerivee) {
			// Autre noeud "avant_k" première valeur de la case (1,k)
			TikZ.texteSourceB += "\\node[left] at (" + positionHorizontale + "*\\Lrg,-1*\\HtX) {$" + TabVar.vd[k][0] + "$};\n";
		}
		if (TabVar.vd[k][1] !== "" && TabVar.yaLaDerivee) {
			// Autre noeud "après_k" seconde valeur de la case (1,k)
			TikZ.texteSourceB += "\\node[right] at (" + positionHorizontale + "*\\Lrg,-1*\\HtX) {$" + TabVar.vd[k][1] + "$};\n";
		}
	} else if (TabVar.yaLaDerivee) {
		// Pas de Split valeur unique
		TikZ.texteSourceB += "\\node at (" + positionHorizontale + "*\\Lrg,-1*\\HtX) {$" + TabVar.vd[k][0] + "$};\n";

	}
	// Prise en charge du signe de la dérivée ou des variations
	if (TabVar.sd[k][0] === "+" || TabVar.sd[k][0] === "-") {
		// Signe de la dérivée (+ ou -)
		if (TabVar.yaLaDerivee) {
			TikZ.texteSourceB += "\\node at (" + (positionHorizontale + 1) + "*\\Lrg,-1*\\HtX) {$" + TabVar.sd[k] + "$};\n";
		}
	} else {
		// on mémorise la position de la zone vide (?)
		if (k + 1 < TabVar.nbCol - 1) {
			TikZ.zoneVide.push([positionHorizontale + "*\\Lrg", (positionHorizontale + 2) + "*\\Lrg"]);
		}
	}
};

//============= TikZ.creerTexteSourceLigneD =============
TikZ.creerTexteSourceLigneD = function () {
	var k, positionHorizontale;
	if (TabVar.yaLaDerivee) {
		// % Ligne de la dérivée
		TikZ.texteSourceB += "% Ligne de la dérivée : f'(x)\n";
		// Premier noeud "y'" valeur de la case (1,0)
		TikZ.texteSourceB += "\\node at (-1*\\Lrg,-1*\\HtX) {$" + TabVar.vd[0] + "$};\n";
	}
	positionHorizontale = 0;
	// Position verticale des doubles barres dans la ligne de la dérivée
	// Ex: ["2*\Lrg", "4*\Lrg", ...]
	TikZ.doubleBarreD = [];
	// Positions verticales Deb Fin des zones vides 
	// Ex: [["2*\Lrg", "4*\Lrg"],...]
	TikZ.zoneVide = [];
	for (k = 1; k < TabVar.nbCol; k += 1) {
		// pour les autres noeuds
		TikZ.defD(positionHorizontale, k);
		positionHorizontale += 2;
	}
};

//============= TikZ.creerTexteSourceLigneX =============
TikZ.creerTexteSourceLigneX = function () {
	var k, positionHorizontale;
	// % Ligne de l'abscisse
	TikZ.texteSourceB += "% Ligne de l'abscisse : x\n";
	// Premier noeud "x" valeur de la case (0,0)
	TikZ.texteSourceB += "\\node at (-1*\\Lrg,0) {$" + TabVar.vx[0] + "$};\n";
	positionHorizontale = 0;
	for (k = 1; k < TabVar.nbCol; k += 1) {
		// Autre noeud "x_k" valeur de la case (0,k)
		TikZ.texteSourceB += "\\node at (" + positionHorizontale + "*\\Lrg,0) {$" + TabVar.vx[k] + "$};\n";
		positionHorizontale += 2;
	}
	// Largeur (positon \droite par rapport à \gauche)
	TikZ.texteSourceA += "% Largeur du tableau\n";
	TikZ.texteSourceA += "\\def\\gauche{-1.5*\\Lrg}\n";
	TikZ.texteSourceA += "\\def\\droite{" + (positionHorizontale - 1.5) + "*\\Lrg}\n";
};

//============= TikZ.creerTexteSource =============
TikZ.creerTexteSource = function () {
	var hauteur, k;
	// Après TabVar.lireTable();
	// TabVar.vx contient les valeurs des cases de la première ligne (x)
	// TabVar.vd contient les valeurs de la dérivée splitées (y')
	// TabVar.sd contient les signes de la dérivée (+ - ?)
	// TabVar.vy contient les valeurs de la fontion splitées (y)
	// Exemple avec TabVar.nbCol = 4
	// [x ] [x1  ]       [x2  ]       [x3  ]
	// [y'] [a:b ] [+  ] [c:d ] [-  ] [e:f ]
	// [y ] [r:s ]       [t:u ]       [v:w ]
	// TabVar.vx = ["x", "x1", "x2", "x3"]
	// TabVar.vd = [["y'"], ["a", "b"], [ "c", "d"], ["e", "f"]]
	// TabVar.sd = ["?", "+", "-", "?"]
	// TabVar.vy = [["y"], ["r", "s"], ["t", "u"], ["v", "w"]])
	TikZ.texteSourceA = TikZ.SourceDefinitions;
	TikZ.creerTexteSourceLigneX();
	TikZ.creerTexteSourceLigneD();
	TikZ.creerTexteSourceLigneY();
	// Non définitions
	if (TikZ.doubleBarreD.length > 0 || TikZ.doubleBarreY.length > 0) {
		// place les macros de définiton des doubles barres
		if (TabVar.yaLaDerivee && TabVar.yaLaFonction) {
			// pour la dérivée et la fonction
			TikZ.texteSourceB += TikZ.SourceBetBB + "\n";
		} else if (TabVar.yaLaFonction) {
			// pour la fonction seulement
			TikZ.texteSourceB += TikZ.SourceBB + "\n";
		} else {
			// pour la dérivée seulement
			TikZ.texteSourceB += TikZ.SourceB + "\n";
		}
		// on trace les doubles barres
		if (TabVar.yaLaDerivee) {
			// pour la dérivée
			for (k = 0; k < TikZ.doubleBarreD.length; k += 1) {
				TikZ.texteSourceB += "\\b{" + TikZ.doubleBarreD[k] + "}\n";
			}
		}
		if (TabVar.yaLaFonction) {
			// pour la fonction
			for (k = 0; k < TikZ.doubleBarreY.length; k += 1) {
				TikZ.texteSourceB += "\\bb{" + TikZ.doubleBarreY[k] + "}\n";
			}
		}
	}
	if (TikZ.zoneVide.length > 0) {
		// place les macros de définiton des zones de non définiton
		if (TabVar.yaLaDerivee && TabVar.yaLaFonction) {
			// pour la dérivée et la fonction
			TikZ.texteSourceB += TikZ.SourceZdeDetY + "\n";
		} else if (TabVar.yaLaFonction) {
			// pour la fonction seulement
			TikZ.texteSourceB += TikZ.SourceZdeY + "\n";
		} else {
			// pour la dérivée seulement
			TikZ.texteSourceB += TikZ.SourceZdeD + "\n";
		}
		// on trace les zones de non définiton
		for (k = 0; k < TikZ.zoneVide.length; k += 1) {
			TikZ.texteSourceB += "\\z{" + TikZ.zoneVide[k][0] + "}{" + TikZ.zoneVide[k][1] + "}\n";
		}
	}
	// Fin du source
	if (TabVar.yaLaDerivee && TabVar.yaLaFonction) {
		// cadre pour la dérivée et la fonction 
		TikZ.texteSourceB += TikZ.SourceFinPourDetY + "\n";
	} else if (TabVar.yaLaFonction) {
		// cadre pour la fonction seulement
		TikZ.texteSourceB += TikZ.SourceFinPourY + "\n";
	} else {
		// cadre pour la dérivée seulement
		TikZ.texteSourceB += TikZ.SourceFinPourD + "\n";
	}
	TikZ.ajouterPointilles();
	TikZ.ajouterLeDebug();
	// ajout éventuel de l'échelle
	hauteur = 3 + 0.5 * TikZ.hauteurTotale;
	if (hauteur > TabVar.echelle) {
		TikZ.texteSource = TikZ.SourceDebut + "[scale=" + (TabVar.echelle / hauteur) + "]\n" + TikZ.texteSourceA + TikZ.texteSourceB;
	} else {
		TikZ.texteSource = TikZ.SourceDebut + "[scale=1]\n" + TikZ.texteSourceA + TikZ.texteSourceB;
	}
	TikZ.texteSource += "%:>>>>> code du tableau à ré-injecter\n";
	TikZ.texteSource += TabVar.tableDefinitionExo('%');
};

//============= TabVar.sourceTikZ =============
TabVar.sourceTikZ = function () {
	TabVar.lireTable();
	TikZ.creerTexteSource();
	GUI.dom.texte.value = TikZ.texteSource;
	GUI.dom.texte.focus();
	GUI.dom.texte.select();
};

//============= TabVar.lireTable =============
TabVar.lireTable = function () {
	// TabVar.vx contient les valeurs des cases de la première ligne (x)
	// TabVar.vd contient les valeurs de la dérivée splitées (y')
	// TabVar.sd contient les signes de la dérivée (+ - ?)
	// TabVar.vy contient les valeurs de la fontion splitées (y)
	// Exemple avec TabVar.nbCol = 4
	// [x ] [x1  ]       [x2  ]       [x3  ]
	// [y'] [a:b ] [+  ] [c:d ] [-  ] [e:f ]
	// [y ] [r:s ]       [t:u ]       [v:w ]
	// TabVar.vx = ["x", "x1", "x2", "x3"]
	// TabVar.vd = [["y'"], ["a", "b"], [ "c", "d"], ["e", "f"]]
	// TabVar.sd = ["?", "+", "-", "?"]
	// TabVar.vy = [["y"], ["r", "s"], ["t", "u"], ["v", "w"]])
	var k;
	TabVar.vx = [];
	TabVar.vd = []; // valeurs
	TabVar.sd = []; // signe
	TabVar.vy = [];
	for (k = 0; k < TabVar.nbCol; k += 1) {
		TabVar.vx[k] = GUI.dom.x[k].value;
		TabVar.vd[k] = GUI.dom.d[k].value.split(":");
		if (k === TabVar.nbCol - 1) {
			TabVar.sd[k] = "?";
		} else if (k > 0) {
			TabVar.sd[k] = GUI.dom.s[k].value;
		} else {
			TabVar.sd[k] = "?";
		}
		TabVar.vy[k] = GUI.dom.y[k].value.split(":");
	}
};

//============= TabVar.ecrireTable =============
TabVar.ecrireTable = function (nmax) {
	var k, n;
	n = TabVar.nbCol > nmax ? nmax : TabVar.nbCol;
	GUI.dom.x[0].value = TabVar.vx[0];
	GUI.dom.d[0].value = TabVar.vd[0];
	GUI.dom.y[0].value = TabVar.vy[0];
	for (k = 1; k < n; k += 1) {
		GUI.dom.x[k].value = TabVar.vx[k];
		GUI.dom.d[k].value = TabVar.vd[k].join(":");
		if (k < n - 1) {
			GUI.dom.s[k].value = TabVar.sd[k];
		}
		GUI.dom.y[k].value = TabVar.vy[k].join(":");
	}
};

//================== Contrôle Interface ==================
//================== TabVar.clicAide ==================
TabVar.clicAide = function () {
	if (GUI.dom.aide.className) {
		GUI.dom.btnAide.innerHTML = "Cacher le mode d'emploi";
		GUI.dom.aide.className = null;
	} else {
		GUI.dom.btnAide.innerHTML = "Mode d'emploi";
		GUI.dom.aide.className = "invisible";
	}
};

//================== TabVar.clicRAZ ==================
TabVar.clicRAZ = function () {
	var k;
	TikZ.texteSource = "";
	TikZ.texteSourceA = "";
	TikZ.texteSourceB = "";
	TabVar.vx = [];
	TabVar.vd = []; // valeurs
	TabVar.sd = []; // signe
	TabVar.vy = [];
	TabVar.vx[0] = "x";
	TabVar.vd[0] = "f'(x)";
	TabVar.vy[0] = "f(x)";
	for (k = 1; k < TabVar.nbCol; k += 1) {
		TabVar.vx[k] = "";
		TabVar.vd[k] = [""];
		TabVar.sd[k] = "";
		TabVar.vy[k] = [""];
	}
	TabVar.ecrireTable(TabVar.nbCol);
	GUI.dom.texte.value = "";
	TabVar.numeroExo = undefined;
};

//================== TabVar.clicValider ==================
TabVar.clicValider = function () {
	TikZ.texteSource = "";
	TikZ.texteSourceA = "";
	TikZ.texteSourceB = "";
	TabVar.sourceTikZ();
};

//============= TabVar.clicMoins =============
TabVar.clicMoins = function () {
	if (TabVar.nbCol > 3) {
		TabVar.lireTable();
		TabVar.nbCol -= 1;
		GUI.creerTable();
		TabVar.ecrireTable(TabVar.nbCol);
	}
};

//============= TabVar.clicPlus =============
TabVar.clicPlus = function () {
	TabVar.lireTable();
	TabVar.nbCol += 1;
	GUI.creerTable();
	TabVar.ecrireTable(TabVar.nbCol - 1);
};

//============= TabVar.clicScale =============
TabVar.clicScale = function (widget) {
	TabVar.echelle = Number(widget.value);
	TikZ.texteSource = "";
	TikZ.texteSourceA = "";
	TikZ.texteSourceB = "";
	TabVar.sourceTikZ();
};

//============= TabVar.clicFonction =============
TabVar.clicFonction = function (widget) {
	TabVar.yaLaFonction = !widget.checked;
	TikZ.texteSource = "";
	TikZ.texteSourceA = "";
	TikZ.texteSourceB = "";
	if (!TabVar.yaLaFonction && !TabVar.yaLaDerivee) {
		GUI.dom.caseDerive.checked = false;
		TabVar.yaLaDerivee = true;
	}
	TabVar.sourceTikZ();
};

//============= TabVar.clicDerive =============
TabVar.clicDerive = function (widget) {
	TabVar.yaLaDerivee = !widget.checked;
	TikZ.texteSource = "";
	TikZ.texteSourceA = "";
	TikZ.texteSourceB = "";
	if (!TabVar.yaLaFonction && !TabVar.yaLaDerivee) {
		GUI.dom.caseFonction.checked = false;
		TabVar.yaLaFonction = true;
	}
	TabVar.sourceTikZ();
};

//============= TabVar.clicPointilles =============
TabVar.clicPointilles = function (widget) {
	TabVar.yaLesPointilles = widget.checked;
	TikZ.texteSource = "";
	TikZ.texteSourceA = "";
	TikZ.texteSourceB = "";
	TabVar.sourceTikZ();
};

//================== TabVar.clicDebug ==================
TabVar.clicDebug = function () {
	TabVar.debug = !TabVar.debug;
	TabVar.numeroExo = undefined;
	if (TabVar.debug) {
		GUI.dom.menuDebug.className = null;
	} else {
		GUI.dom.menuDebug.className = "invisible";
	}
};

//================== TabVar.selectExo ==================
TabVar.selectExo = function () {
	var k, exo;
	if (GUI.dom.menu.selectedIndex === 0) {
		return;
	}
	TabVar.clicRAZ();
	TabVar.numeroExo = GUI.dom.menu.selectedIndex - 1;
	exo = EXEMPLES[TabVar.numeroExo];
	TabVar.nbCol = exo.length;
	GUI.creerTable();
	TabVar.vx = [];
	TabVar.vd = []; // valeurs
	TabVar.sd = []; // signe
	TabVar.vy = [];
	TabVar.vx[0] = exo[0][0];
	TabVar.vd[0] = exo[0][1];
	TabVar.vy[0] = exo[0][2];
	for (k = 1; k < TabVar.nbCol; k += 1) {
		TabVar.vx[k] = exo[k][0];
		TabVar.vd[k] = [exo[k][1]];
		TabVar.sd[k] = exo[k][2];
		TabVar.vy[k] = [exo[k][3]];
	}
	TabVar.ecrireTable(TabVar.nbCol);
	GUI.dom.texte.value = "Exerice n° " + TabVar.numeroExo;
	GUI.dom.menu.selectedIndex = 0;
};

//============= TabVar.tableDefinitionExo =============
TabVar.tableDefinitionExo = function (prefixe) {
	var pef, txt, k;
	pef = prefixe || "\t";
	TabVar.lireTable();
	txt = pef + '[\n';
	txt += pef + '\t["' + TabVar.vx[0];
	txt += '", "' + TabVar.vd[0];
	txt += '", "' + TabVar.vy[0] + '"]';
	for (k = 1; k < TabVar.nbCol; k += 1) {
		txt += ',\n' + pef + '\t["' + TabVar.vx[k];
		txt += '", "' + TabVar.vd[k].join(":");
		txt += '", "' + TabVar.sd[k];
		txt += '", "' + TabVar.vy[k].join(":") + '"]';
	}
	txt += '\n' + pef + ']\n';
	txt = txt.replace(/\\/g, "\\\\");
	return txt;
};

//================== TabVar.defExo ==================
TabVar.defExo = function () {
	GUI.dom.texte.value = TabVar.tableDefinitionExo();
	GUI.dom.texte.focus();
	GUI.dom.texte.select();
};

//================== TabVar.injecterExo ==================
TabVar.injecterExo = function () {
	var k, exo, code, codeLu, ligne;
	codeLu = GUI.dom.texte.value;
	codeLu = codeLu.split("\n");
	code = [];
	for (k = 0; k < codeLu.length; k += 1) {
		ligne = codeLu[k].replace(/^%/, "");
		if (ligne.length > 0) {
			if (ligne.substr(0, 1) !== ":") {
				code.push(ligne);
			}
		}
	}
	code = code.join('\n');
	try {
		exo = eval("(" + code + ")");
	} catch (err) {
		GUI.dom.texte.value = err + "\n----------\n" + code;
		return;
	}
	TabVar.clicRAZ();
	TabVar.nbCol = exo.length;
	GUI.creerTable();
	TabVar.vx = [];
	TabVar.vd = []; // valeurs
	TabVar.sd = []; // signe
	TabVar.vy = [];
	TabVar.vx[0] = exo[0][0];
	TabVar.vd[0] = exo[0][1];
	TabVar.vy[0] = exo[0][2];
	for (k = 1; k < TabVar.nbCol; k += 1) {
		TabVar.vx[k] = exo[k][0];
		TabVar.vd[k] = [exo[k][1]];
		TabVar.sd[k] = exo[k][2];
		TabVar.vy[k] = [exo[k][3]];
	}
	TabVar.ecrireTable(TabVar.nbCol);
	GUI.dom.texte.value = "";
	GUI.dom.menu.selectedIndex = 0;
};

//================== Initialisation du TabVar ==================
//================== TabVar.initTabVar ==================
TabVar.initTabVar = function () {
	TabVar.nbCol = 4;
	GUI.creerTable();
	TabVar.clicRAZ();
};

//================== TabVar.init ==================
TabVar.init = function () {
	TabVar.initTabVar();
	TabVar.echelle = 3.5;
	TabVar.debug = false;
	GUI.creerMenuDebug(EXEMPLES.length);
};
